--- 2008 "alu" VHDL Code 
--- Current file name:  alu.vhd
--- Last Revised:  9/22/2008; 2:00 p.m.
--- Author:  WDR
--- Copyright:  William D. Richard, Ph.D.

LIBRARY IEEE ;
USE IEEE.STD_LOGIC_1164.ALL ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;
use IEEE.STD_LOGIC_ARITH.ALL ;

ENTITY alu IS
   PORT (a      : IN  STD_LOGIC_VECTOR(31 DOWNTO 0) ;
         b      : IN  STD_LOGIC_VECTOR(31 DOWNTO 0) ;
         add    : IN  STD_LOGIC ;
         sub    : IN  STD_LOGIC ;
         andx   : IN  STD_LOGIC ;
         c_eq_b : IN  STD_LOGIC ;
         inc4   : IN  STD_LOGIC ;
         neg    : IN  STD_LOGIC ;
         shr    : IN  STD_LOGIC ;
         shl    : IN  STD_LOGIC ;
         shc    : IN  STD_LOGIC ;
         shra   : IN  STD_LOGIC ;
         orx    : IN  STD_LOGIC ;
         notx   : IN  STD_LOGIC ;
         c     : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)) ;
END alu ;

ARCHITECTURE behavioral OF alu IS

   SIGNAL mysel : STD_LOGIC_VECTOR(11 downto 0) ;

BEGIN

   mysel <= STD_LOGIC_VECTOR'(add,sub,andx,c_eq_b,inc4,neg,shr,shl,shc,shra,orx,notx) ;

   WITH mysel SELECT
      c <= a + b                        WHEN "100000000000" ,
           a - b                        WHEN "010000000000" ,
           a AND b                      WHEN "001000000000" ,
           b                            WHEN "000100000000" ,
           b + 4                        WHEN "000010000000" ,
           0 - b                        WHEN "000001000000" ,
           '0' & b(31 DOWNTO 1)         WHEN "000000100000" ,
           b(30 DOWNTO 0) & '0'         WHEN "000000010000" ,
           b(0) & b(31 DOWNTO 1)        WHEN "000000001000" ,
           b(31) & b(31 DOWNTO 1)       WHEN "000000000100" ,
           a OR b                       WHEN "000000000010" ,
           NOT(b)                       WHEN "000000000001" ,
           b                            WHEN OTHERS ;

END behavioral ;
