--- 2000 "bigsram" VHDL Code 
--- Current file name:  bigsram.vhd
--- Last Revised:  10/9/2000; 10:50 a.m.
--- Author:  WDR
--- Copyright:  William D. Richard, Ph.D.

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL ;
USE IEEE.STD_LOGIC_ARITH.ALL ;

ENTITY sram IS
   PORT (d        : INOUT STD_LOGIC_VECTOR(31 DOWNTO 0) ;
         address  : IN    STD_LOGIC_VECTOR(31 DOWNTO 0) ;
         read     : IN    STD_LOGIC ;
         write    : IN    STD_LOGIC ;
         clk      : IN    STD_LOGIC) ;
END sram ;

ARCHITECTURE behavioral OF sram IS

   TYPE memoryarray IS ARRAY(8191 DOWNTO 0) OF STD_LOGIC_VECTOR(31 DOWNTO 0) ;

   SIGNAL myarray : memoryarray ;

   SIGNAL myindex : INTEGER RANGE 0 TO 8191 ;

   SIGNAL temp : UNSIGNED(12 DOWNTO 0) ;

BEGIN

   temp <= UNSIGNED(address(14 DOWNTO 2)) ;

   myindex <= CONV_INTEGER(temp) ;

   writeprocess:PROCESS(clk)
   begin
      IF (Clk = '1' AND Clk'event) THEN
         IF (address(31 DOWNTO 15) = "00000000000000001" AND
             write = '1' AND read = '0') THEN
            myarray(myindex) <= d(31 DOWNTO 0); 
         END IF;
      END IF;
   END PROCESS writeprocess ;

   readprocess:PROCESS(clk,address,read,write,myarray,myindex)
   begin
      IF (address(31 DOWNTO 15) = "00000000000000001" AND
          read = '1' AND write = '0' AND clk = '0') THEN
         d(31 DOWNTO 0) <= myarray(myindex) ;
      else
	 d(31 DOWNTO 0) <= (OTHERS => 'Z') ;
      END IF;
   END PROCESS readprocess ; 

END behavioral ;
