--- 2000 "conbit" VHDL Code 
--- Current file name:  conbit.vhd
--- Last Revised:  10/3/2000; 11:45 a.m.
--- Author:  WDR
--- Copyright:  William D. Richard, Ph.D.

LIBRARY IEEE ;
USE IEEE.STD_LOGIC_1164.ALL ;

ENTITY conbit IS
   PORT (bus_in   : IN  STD_LOGIC_VECTOR(31 DOWNTO 0) ;
         ir       : IN  STD_LOGIC_VECTOR(31 DOWNTO 0) ;
         reset_l  : IN  STD_LOGIC ;
         clk      : IN  STD_LOGIC ;
         con      : OUT STD_LOGIC ;
         con_in   : IN  STD_LOGIC) ;
END conbit ;

ARCHITECTURE behavioral OF conbit IS

BEGIN

   conbit:PROCESS(clk)
   BEGIN
      IF (clk = '1' AND clk'EVENT) THEN
         IF (reset_l = '0') THEN
            con <= '0' ;
	 ELSIF (con_in = '1') THEN
            IF (ir(2 DOWNTO 0) = "001") THEN
               con <= '1' ;
            ELSIF (ir(2 DOWNTO 0) = "010") AND (bus_in = "00000000000000000000000000000000") THEN
               con <= '1' ;
            ELSIF (ir(2 DOWNTO 0) = "011") AND (NOT(bus_in = "00000000000000000000000000000000")) THEN
               con <= '1' ;
            ELSIF (ir(2 DOWNTO 0) = "100") AND (bus_in(31) = '0') THEN
               con <= '1' ;
            ELSIF (ir(2 DOWNTO 0) = "101") AND (bus_in(31) = '1') THEN
               con <= '1' ;
            ELSE
               con <= '0' ;
            END IF ;
         END IF ;
      END IF ;
   END PROCESS conbit ; 

END behavioral ;
