--- 2000 "eprom" VHDL Code 
--- Current file name:  eprom.vhd
--- Last Revised:  10/09/2000; 3:45 p.m.
--- Author:  WDR
--- Copyright:  William D. Richard, Ph.D.

LIBRARY IEEE ;
USE IEEE.STD_LOGIC_1164.ALL ;
USE IEEE.STD_LOGIC_ARITH.ALL;
ENTITY eprom IS
   PORT (d        : OUT STD_LOGIC_VECTOR(31 DOWNTO 0) ;
         address  : IN  STD_LOGIC_VECTOR(31 DOWNTO 0) ;
         read     : IN  STD_LOGIC ;
         write    : IN  STD_LOGIC ;
         clk      : IN  STD_LOGIC) ;
END eprom ;

ARCHITECTURE behavioral OF eprom IS

   SIGNAL data    : STD_LOGIC_VECTOR(31 DOWNTO 0) ;

BEGIN
   WITH address  SELECT
   data <=
     X"28400001" WHEN X"00000000" ,
     X"28800002" WHEN X"00000004" ,
     X"60c22000" WHEN X"00000008" ,
     X"29008000" WHEN X"0000000c" ,
     X"18c80000" WHEN X"00000010" ,
     X"09008000" WHEN X"00000014" ,
     X"f8000000" WHEN X"00000018" , 
     X"00000000" WHEN OTHERS ;

   readprocess:PROCESS(clk,address,read,write,data)
   begin
      IF (address(31 DOWNTO 15) = "00000000000000000" AND
          read = '1' AND write = '0' AND clk = '0') THEN
         d(31 DOWNTO 0) <= data ;
      else
	 d(31 DOWNTO 0) <= (OTHERS => 'Z') ;
      END IF;
   END PROCESS readprocess ; 

END behavioral ;
