--- 2000 "md" VHDL Code 
--- Current file name:  md.vhd
--- Last Revised:  10/3/2000; 2:45 p.m.
--- Author:  WDR
--- Copyright:  William D. Richard, Ph.D.

LIBRARY IEEE ;
USE IEEE.STD_LOGIC_1164.ALL ;

ENTITY md IS
   PORT (bus_in   : IN  STD_LOGIC_VECTOR(31 DOWNTO 0) ;
         clk      : IN  STD_LOGIC ;
         md_rd    : IN  STD_LOGIC ;
         md_wr    : IN  STD_LOGIC ;
         md_out   : IN  STD_LOGIC ;
         md_bus   : IN  STD_LOGIC ;
         d        : INOUT STD_LOGIC_VECTOR(31 DOWNTO 0) ;
         bus_out  : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)) ;
END md ;

ARCHITECTURE behavioral OF md IS

   SIGNAL md : STD_LOGIC_VECTOR(31 DOWNTO 0) ;

BEGIN

   mdreg:PROCESS(clk)
   BEGIN
      IF (clk = '1' AND clk'EVENT) THEN
	 IF (md_bus = '1') THEN
	    md(31 DOWNTO 0) <= bus_in(31 DOWNTO 0) ;
         ELSIF (md_rd = '1') THEN
            md(31 DOWNTO 0) <= d(31 DOWNTO 0) ;
         END IF ;
      END IF ;
   END PROCESS mdreg ; 

   mddrive:PROCESS(md_out,md)
   BEGIN
      IF (md_out = '1') THEN
         bus_out <= md ;
      ELSE
	 bus_out <= (OTHERS => 'Z') ;
      END IF ;
   END PROCESS mddrive ;

   pindrive:PROCESS(md,md_wr,d)
   BEGIN
      IF (md_wr = '1') THEN
         d <= md ;
      ELSE
	 d <= (OTHERS => 'Z') ;
      END IF ;
   END PROCESS pindrive ;

END behavioral ;
