--- 2000 "shiftcounter" VHDL Code 
--- Current file name:  shiftcounter.vhd
--- Last Revised:  2/15/2000; 8:51 a.m.
--- Author:  WDR
--- Copyright:  William D. Richard, Ph.D.

LIBRARY IEEE ;
USE IEEE.STD_LOGIC_1164.ALL ;
USE IEEE.STD_LOGIC_ARITH.ALL;

ENTITY shiftcounter IS
   PORT (clk       : IN  STD_LOGIC ;
         decr      : IN  STD_LOGIC ;
         ld        : IN  STD_LOGIC ;
         n_eq_zero : OUT STD_LOGIC ;
         bus_in    : IN  STD_LOGIC_VECTOR(4 DOWNTO 0)) ;
END shiftcounter ;

ARCHITECTURE behavioral OF shiftcounter IS

   SIGNAL shift_cnt      : UNSIGNED(4 DOWNTO 0) ;

BEGIN

   shiftcounter:PROCESS(clk)
   BEGIN
      IF (clk = '1' AND clk'EVENT) THEN
	 IF (ld = '1') THEN
	    shift_cnt <= UNSIGNED(bus_in(4 DOWNTO 0)) ;
         ELSIF (decr = '1') THEN
	    shift_cnt <= shift_cnt - 1 ;
         END IF ;
      END IF ;
   END PROCESS shiftcounter ; 

   n_eq_zero <= '1' WHEN (shift_cnt = 0) ELSE '0' ;

END behavioral ;
