--- 2000 "testbench" VHDL Code 
--- Current file name:  testbench.vhd
--- Last Revised:  10/09/2000; 3:50 p.m.
--- Author:  WDR
--- Copyright:  William D. Richard, Ph.D.

LIBRARY IEEE ;
USE IEEE.STD_LOGIC_1164.ALL ;
USE IEEE.STD_LOGIC_ARITH.ALL ;

--- library work;

entity testbench is
   PORT(clk:      in    STD_LOGIC;
        reset_l:  in    STD_LOGIC);
end testbench ;

architecture structure of testbench is

   COMPONENT src
   PORT(clk      : IN    STD_LOGIC ;
        reset_l  : IN    STD_LOGIC ;
        d        : INOUT STD_LOGIC_VECTOR(31 DOWNTO 0) ;
        address  : OUT   STD_LOGIC_VECTOR(31 DOWNTO 0) ;
        read     : OUT   STD_LOGIC ;
        write    : OUT   STD_LOGIC ;
        done     : IN    STD_LOGIC) ;
   END COMPONENT ;

   COMPONENT eprom
      PORT(d        : OUT STD_LOGIC_VECTOR(31 DOWNTO 0) ;
           address  : IN  STD_LOGIC_VECTOR(31 DOWNTO 0) ;
           read     : IN  STD_LOGIC ;
           write    : IN  STD_LOGIC ;
           clk      : IN  STD_LOGIC) ;
   end COMPONENT ;

   COMPONENT sram
      PORT (d        : INOUT STD_LOGIC_VECTOR(31 DOWNTO 0) ;
            address  : IN    STD_LOGIC_VECTOR(31 DOWNTO 0) ;
            read     : IN    STD_LOGIC ;
            write    : IN    STD_LOGIC ;
            clk      : IN    STD_LOGIC) ;
   end COMPONENT ;

   SIGNAL  d        :  STD_LOGIC_VECTOR(31 downto 0):= "00000000000000000000000000000000" ;
   SIGNAL  address  :  STD_LOGIC_VECTOR(31 downto 0):= "00000000000000000000000000000000" ;
   SIGNAL  read     :  STD_LOGIC;
   SIGNAL  write    :  STD_LOGIC;
   SIGNAL  done     :  STD_LOGIC; 

   BEGIN

   done <= '1' ;

   src1:src      
      PORT MAP(clk       => clk,
               reset_l   => reset_l,
               d         => d,
               address   => address,
               read      => read,
               write     => write,
               done      => done);

   erpom1:eprom    
      PORT MAP(d         => d,
               address   => address,
               read      => read ,
               write     => write ,
               clk       => clk);
 
   sram1: sram
      PORT MAP(d         => d,
               address   => address,
               read      => read,
               write     => write,
               clk       => clk);

   END structure;
